<template>
  <div>
    <Category v-for="cat in categoryList" :key="cat.id" :category="cat" />
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { CategoryModel } from "@/interfaces/interfaces";
import CategoryService from "@/services/CategoriesService";
import Category from "@/components/Category.vue";

@Component({
  components: {
    Category
  }
})
export default class CategoryList extends Vue {
  private categoryList: Array<CategoryModel> = new Array<CategoryModel>();
  private activeKey = ["1"];
  private collapseKey = 1;

  created() {
    this.GetCategories();
  }

  private async GetCategories() {
    const categoryService = new CategoryService();

    await categoryService
      .GetAllCaegories()
      .then(response => {
        this.setCategoryList(response);
      })
      .catch(err => {
        alert(err);
        console.log(err);
      });
  }

  private setCategoryList(categoryList: Array<CategoryModel>) {
    categoryList.forEach(c => this.categoryList.push(c));
  }
}
</script>
